Option Compare Text
Imports System.IO
Imports TextSearch.PhoneDts
Imports Microsoft.VisualBasic.ControlChars

Public Class frmTextSearch

   Private _Datafile As New FileInfo("..\..\PhoneDts.xml")

   Private Sub frmPhonebook_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
      Location = Screen.PrimaryScreen.WorkingArea.Location
      Reload()
   End Sub

   Private Sub Reload()
      PhoneDts.Clear()
      SetDataLoading(PhoneDts, True)
      PhoneDts.ReadXml(_Datafile.FullName)
      SetDataLoading(PhoneDts, False)
   End Sub

   ''' <summary>
   ''' deaktiviert whrend des Ladens AktualisierungsVorgnge des Databindings
   ''' </summary>
   Private Sub SetDataLoading(ByVal dts As DataSet, ByVal Value As Boolean)
      For Each tb As DataTable In dts.Tables
         If Value Then
            tb.BeginLoadData()
         Else
            tb.EndLoadData()
         End If
      Next
   End Sub

   Private Sub Save()
      Me.Validate()
      PhoneDts.WriteXml(_Datafile.FullName)
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, _
         TestToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
            Save()
         Case Sender Is ReloadToolStripMenuItem
            Reload()
         Case Sender Is TestToolStripMenuItem
            Me.PhoneDts.Title.Clear()
            Me.PhoneDts.Person.Clear()
      End Select
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub frmPhonebook_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate() 'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenns sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub

   Private Function FindName(pattern As String) As Boolean
      For i = 0 To Me.PersonBindingSource.Count - 1
         Dim person = DirectCast(DirectCast(PersonBindingSource(i), DataRowView).Row, PersonRow)
         If person.Name Like pattern Then
            PersonBindingSource.Position = i
            Return True
         End If
      Next
      Return False
   End Function

   Private Sub btSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSearch.Click
      If FindName(txtSearch.Text) Then
         Dim person = DirectCast(DirectCast(PersonBindingSource.Current, DataRowView).Row, PersonRow)
         With person
            MessageBox.Show(String.Format("{1} {2}{0}Geb: {3:d}{0}Tel: {4}", Lf, .FirstName, .Name, .Birth, .Mobil))
         End With
      Else
         MessageBox.Show(String.Concat("Fr '", txtSearch.Text, "' wurde kein Match gefunden"))
      End If
   End Sub
End Class